/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package it.tref.liferay.mapit.map.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import it.tref.liferay.mapit.map.model.Plugin;
import it.tref.liferay.mapit.map.model.PluginModel;

import java.io.Serializable;

import java.sql.Types;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * The base model implementation for the Plugin service. Represents a row in the &quot;MI_Map_Plugin&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link it.tref.liferay.mapit.map.model.PluginModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link PluginImpl}.
 * </p>
 *
 * @author
 * @see PluginImpl
 * @see it.tref.liferay.mapit.map.model.Plugin
 * @see it.tref.liferay.mapit.map.model.PluginModel
 * @generated
 */
public class PluginModelImpl extends BaseModelImpl<Plugin>
	implements PluginModel {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. All methods that expect a plugin model instance should use the {@link it.tref.liferay.mapit.map.model.Plugin} interface instead.
	 */
	public static final String TABLE_NAME = "MI_Map_Plugin";
	public static final Object[][] TABLE_COLUMNS = {
			{ "pluginId", Types.BIGINT },
			{ "createDate", Types.TIMESTAMP },
			{ "modifiedDate", Types.TIMESTAMP },
			{ "name", Types.VARCHAR },
			{ "version", Types.VARCHAR },
			{ "mapItVersion", Types.VARCHAR },
			{ "context", Types.VARCHAR },
			{ "active_", Types.BOOLEAN }
		};
	public static final String TABLE_SQL_CREATE = "create table MI_Map_Plugin (pluginId LONG not null primary key,createDate DATE null,modifiedDate DATE null,name VARCHAR(200) null,version VARCHAR(75) null,mapItVersion VARCHAR(75) null,context VARCHAR(200) null,active_ BOOLEAN)";
	public static final String TABLE_SQL_DROP = "drop table MI_Map_Plugin";
	public static final String ORDER_BY_JPQL = " ORDER BY plugin.context ASC";
	public static final String ORDER_BY_SQL = " ORDER BY MI_Map_Plugin.context ASC";
	public static final String DATA_SOURCE = "liferayDataSource";
	public static final String SESSION_FACTORY = "liferaySessionFactory";
	public static final String TX_MANAGER = "liferayTransactionManager";
	public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.entity.cache.enabled.it.tref.liferay.mapit.map.model.Plugin"),
			true);
	public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.finder.cache.enabled.it.tref.liferay.mapit.map.model.Plugin"),
			true);
	public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.column.bitmask.enabled.it.tref.liferay.mapit.map.model.Plugin"),
			true);
	public static long ACTIVE_COLUMN_BITMASK = 1L;
	public static long CONTEXT_COLUMN_BITMASK = 2L;
	public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
				"lock.expiration.time.it.tref.liferay.mapit.map.model.Plugin"));

	public PluginModelImpl() {
	}

	@Override
	public long getPrimaryKey() {
		return _pluginId;
	}

	@Override
	public void setPrimaryKey(long primaryKey) {
		setPluginId(primaryKey);
	}

	@Override
	public Serializable getPrimaryKeyObj() {
		return _pluginId;
	}

	@Override
	public void setPrimaryKeyObj(Serializable primaryKeyObj) {
		setPrimaryKey(((Long)primaryKeyObj).longValue());
	}

	@Override
	public Class<?> getModelClass() {
		return Plugin.class;
	}

	@Override
	public String getModelClassName() {
		return Plugin.class.getName();
	}

	@Override
	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("pluginId", getPluginId());
		attributes.put("createDate", getCreateDate());
		attributes.put("modifiedDate", getModifiedDate());
		attributes.put("name", getName());
		attributes.put("version", getVersion());
		attributes.put("mapItVersion", getMapItVersion());
		attributes.put("context", getContext());
		attributes.put("active", getActive());

		return attributes;
	}

	@Override
	public void setModelAttributes(Map<String, Object> attributes) {
		Long pluginId = (Long)attributes.get("pluginId");

		if (pluginId != null) {
			setPluginId(pluginId);
		}

		Date createDate = (Date)attributes.get("createDate");

		if (createDate != null) {
			setCreateDate(createDate);
		}

		Date modifiedDate = (Date)attributes.get("modifiedDate");

		if (modifiedDate != null) {
			setModifiedDate(modifiedDate);
		}

		String name = (String)attributes.get("name");

		if (name != null) {
			setName(name);
		}

		String version = (String)attributes.get("version");

		if (version != null) {
			setVersion(version);
		}

		String mapItVersion = (String)attributes.get("mapItVersion");

		if (mapItVersion != null) {
			setMapItVersion(mapItVersion);
		}

		String context = (String)attributes.get("context");

		if (context != null) {
			setContext(context);
		}

		Boolean active = (Boolean)attributes.get("active");

		if (active != null) {
			setActive(active);
		}
	}

	@Override
	public long getPluginId() {
		return _pluginId;
	}

	@Override
	public void setPluginId(long pluginId) {
		_pluginId = pluginId;
	}

	@Override
	public Date getCreateDate() {
		return _createDate;
	}

	@Override
	public void setCreateDate(Date createDate) {
		_createDate = createDate;
	}

	@Override
	public Date getModifiedDate() {
		return _modifiedDate;
	}

	@Override
	public void setModifiedDate(Date modifiedDate) {
		_modifiedDate = modifiedDate;
	}

	@Override
	public String getName() {
		if (_name == null) {
			return StringPool.BLANK;
		}
		else {
			return _name;
		}
	}

	@Override
	public void setName(String name) {
		_name = name;
	}

	@Override
	public String getVersion() {
		if (_version == null) {
			return StringPool.BLANK;
		}
		else {
			return _version;
		}
	}

	@Override
	public void setVersion(String version) {
		_version = version;
	}

	@Override
	public String getMapItVersion() {
		if (_mapItVersion == null) {
			return StringPool.BLANK;
		}
		else {
			return _mapItVersion;
		}
	}

	@Override
	public void setMapItVersion(String mapItVersion) {
		_mapItVersion = mapItVersion;
	}

	@Override
	public String getContext() {
		if (_context == null) {
			return StringPool.BLANK;
		}
		else {
			return _context;
		}
	}

	@Override
	public void setContext(String context) {
		_columnBitmask = -1L;

		if (_originalContext == null) {
			_originalContext = _context;
		}

		_context = context;
	}

	public String getOriginalContext() {
		return GetterUtil.getString(_originalContext);
	}

	@Override
	public boolean getActive() {
		return _active;
	}

	@Override
	public boolean isActive() {
		return _active;
	}

	@Override
	public void setActive(boolean active) {
		_columnBitmask |= ACTIVE_COLUMN_BITMASK;

		if (!_setOriginalActive) {
			_setOriginalActive = true;

			_originalActive = _active;
		}

		_active = active;
	}

	public boolean getOriginalActive() {
		return _originalActive;
	}

	public long getColumnBitmask() {
		return _columnBitmask;
	}

	@Override
	public ExpandoBridge getExpandoBridge() {
		return ExpandoBridgeFactoryUtil.getExpandoBridge(0,
			Plugin.class.getName(), getPrimaryKey());
	}

	@Override
	public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
		ExpandoBridge expandoBridge = getExpandoBridge();

		expandoBridge.setAttributes(serviceContext);
	}

	@Override
	public Plugin toEscapedModel() {
		if (_escapedModel == null) {
			_escapedModel = (Plugin)ProxyUtil.newProxyInstance(_classLoader,
					_escapedModelInterfaces, new AutoEscapeBeanHandler(this));
		}

		return _escapedModel;
	}

	@Override
	public Object clone() {
		PluginImpl pluginImpl = new PluginImpl();

		pluginImpl.setPluginId(getPluginId());
		pluginImpl.setCreateDate(getCreateDate());
		pluginImpl.setModifiedDate(getModifiedDate());
		pluginImpl.setName(getName());
		pluginImpl.setVersion(getVersion());
		pluginImpl.setMapItVersion(getMapItVersion());
		pluginImpl.setContext(getContext());
		pluginImpl.setActive(getActive());

		pluginImpl.resetOriginalValues();

		return pluginImpl;
	}

	@Override
	public int compareTo(Plugin plugin) {
		int value = 0;

		value = getContext().compareTo(plugin.getContext());

		if (value != 0) {
			return value;
		}

		return 0;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}

		if (!(obj instanceof Plugin)) {
			return false;
		}

		Plugin plugin = (Plugin)obj;

		long primaryKey = plugin.getPrimaryKey();

		if (getPrimaryKey() == primaryKey) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public int hashCode() {
		return (int)getPrimaryKey();
	}

	@Override
	public void resetOriginalValues() {
		PluginModelImpl pluginModelImpl = this;

		pluginModelImpl._originalContext = pluginModelImpl._context;

		pluginModelImpl._originalActive = pluginModelImpl._active;

		pluginModelImpl._setOriginalActive = false;

		pluginModelImpl._columnBitmask = 0;
	}

	@Override
	public CacheModel<Plugin> toCacheModel() {
		PluginCacheModel pluginCacheModel = new PluginCacheModel();

		pluginCacheModel.pluginId = getPluginId();

		Date createDate = getCreateDate();

		if (createDate != null) {
			pluginCacheModel.createDate = createDate.getTime();
		}
		else {
			pluginCacheModel.createDate = Long.MIN_VALUE;
		}

		Date modifiedDate = getModifiedDate();

		if (modifiedDate != null) {
			pluginCacheModel.modifiedDate = modifiedDate.getTime();
		}
		else {
			pluginCacheModel.modifiedDate = Long.MIN_VALUE;
		}

		pluginCacheModel.name = getName();

		String name = pluginCacheModel.name;

		if ((name != null) && (name.length() == 0)) {
			pluginCacheModel.name = null;
		}

		pluginCacheModel.version = getVersion();

		String version = pluginCacheModel.version;

		if ((version != null) && (version.length() == 0)) {
			pluginCacheModel.version = null;
		}

		pluginCacheModel.mapItVersion = getMapItVersion();

		String mapItVersion = pluginCacheModel.mapItVersion;

		if ((mapItVersion != null) && (mapItVersion.length() == 0)) {
			pluginCacheModel.mapItVersion = null;
		}

		pluginCacheModel.context = getContext();

		String context = pluginCacheModel.context;

		if ((context != null) && (context.length() == 0)) {
			pluginCacheModel.context = null;
		}

		pluginCacheModel.active = getActive();

		return pluginCacheModel;
	}

	@Override
	public String toString() {
		StringBundler sb = new StringBundler(17);

		sb.append("{pluginId=");
		sb.append(getPluginId());
		sb.append(", createDate=");
		sb.append(getCreateDate());
		sb.append(", modifiedDate=");
		sb.append(getModifiedDate());
		sb.append(", name=");
		sb.append(getName());
		sb.append(", version=");
		sb.append(getVersion());
		sb.append(", mapItVersion=");
		sb.append(getMapItVersion());
		sb.append(", context=");
		sb.append(getContext());
		sb.append(", active=");
		sb.append(getActive());
		sb.append("}");

		return sb.toString();
	}

	@Override
	public String toXmlString() {
		StringBundler sb = new StringBundler(28);

		sb.append("<model><model-name>");
		sb.append("it.tref.liferay.mapit.map.model.Plugin");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>pluginId</column-name><column-value><![CDATA[");
		sb.append(getPluginId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>createDate</column-name><column-value><![CDATA[");
		sb.append(getCreateDate());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>modifiedDate</column-name><column-value><![CDATA[");
		sb.append(getModifiedDate());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>name</column-name><column-value><![CDATA[");
		sb.append(getName());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>version</column-name><column-value><![CDATA[");
		sb.append(getVersion());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>mapItVersion</column-name><column-value><![CDATA[");
		sb.append(getMapItVersion());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>context</column-name><column-value><![CDATA[");
		sb.append(getContext());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>active</column-name><column-value><![CDATA[");
		sb.append(getActive());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private static ClassLoader _classLoader = Plugin.class.getClassLoader();
	private static Class<?>[] _escapedModelInterfaces = new Class[] { Plugin.class };
	private long _pluginId;
	private Date _createDate;
	private Date _modifiedDate;
	private String _name;
	private String _version;
	private String _mapItVersion;
	private String _context;
	private String _originalContext;
	private boolean _active;
	private boolean _originalActive;
	private boolean _setOriginalActive;
	private long _columnBitmask;
	private Plugin _escapedModel;
}